﻿Type=Service
Version=2.52
@EndOfDesignText@
#Region Module Attributes
	#StartAtBoot: False
#End Region

'Service module
Sub Process_Globals
	Private astreams As AsyncStreams
	Private client As Socket
	Private buffer(4) As Byte
	Private raf As RandomAccessFile
	Private tryingToConnect As Boolean
End Sub
Sub Service_Create
	raf.Initialize3(buffer, True)
	Connect
End Sub

Sub Service_Start (StartingIntent As Intent)

End Sub

Public Sub Send(Image() As Byte)
	If client.IsInitialized = False OR client.Connected = False Then
		Connect
	Else
		raf.WriteInt(Image.Length, 0)
		astreams.Write(buffer)
		astreams.Write(Image)
	End If
End Sub

Private Sub Connect
	If tryingToConnect Then Return
	
	tryingToConnect = True
	Log("Connecting to: " & Main.ServerIp & ":" & Main.ServerPort)
	client.Initialize("client")
	client.Connect(Main.ServerIp, Main.ServerPort, 20000)
End Sub

Sub Client_Connected (Successful As Boolean)
	tryingToConnect = False
	Log("Client_Connected: " & Successful)
	If Successful = False Then
		Log(LastException)
'		ToastMessageShow("Error connecting.", True)
	Else
		astreams.Initialize(client.InputStream, client.OutputStream, "astreams")
	End If
End Sub

Sub AStreams_Error
	Log("AStreams_Error")
	CloseClient
End Sub

Sub AStreams_Terminated
	Log("AStreams_Terminated")
	CloseClient
End Sub

Sub CloseClient
	client.Close
End Sub

Sub Service_Destroy

End Sub
